﻿--[[
	Project: AutoRole
	Version: 1.1.0
	Website: http://wow.curseforge.com/addons/auto-role/
	Author: Erfolg

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>. 
]] 

AutoRole = LibStub("AceAddon-3.0"):NewAddon("AutoRole", "AceConsole-3.0", "AceEvent-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("AutoRole")
local db = nil

damageHidden = nil
tankHidden = nil
healerHidden = nil

local options = {
name = "AutoRole",
handler = AutoRole,
type = "group",

	args = {
	
		descrp = {
		type = "description",
		name = L["addon_desc"],
		order = 0,  
		},

		sep = {
		type = "header",
		name = "",
		order = 1,
		},

		damageEnabled = {
		type = "toggle",
		name = L["Damage"],
		desc = L["DamageDesc"],
		get = function() return db.damageEnabled end,
		set = function(info, value) 
		local db = AutoRole.db.char				
		db.damageEnabled = value
		AutoRole:Update()
		end,
		order = 2,
		},

		tankEnabled = {
		type = "toggle",
		name = L["Tank"],
		desc = L["TankDesc"],
		get = function() return db.tankEnabled end,
		set = function(info, value) 
		local db = AutoRole.db.char				
		db.tankEnabled = value
		AutoRole:Update()
		end,
		order = 3,
		},

		healerEnabled = {
		type = "toggle",
		name = L["Healer"],
		desc = L["HealerDesc"],
		get = function() return db.healerEnabled end,
		set = function(info, value) 
		local db = AutoRole.db.char				
		db.healerEnabled = value
		AutoRole:Update()
		end,
		order = 4,
		},
	},
}

local defaults = {
	char = {
	damageEnabled = false,
	tankEnabled = false,
	healerEnabled = false,
	},
}

function AutoRole:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("AutoRoleDB", defaults, true)
	db = self.db.char
	LibStub("AceConfig-3.0"):RegisterOptionsTable("AutoRole", options)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("AutoRole", "AutoRole")
	self:RegisterChatCommand("autorole", "ChatCommand")
	print (L["OnLoad"])
	print (L["OnLoad2"])
end

--Functions--
function AutoRole:Update()
	--Damage
	if self:IsEnabled() and db.damageEnabled then
		if not damageenabled then 
			isRaidHidden = true
			AutoRole:Damage()
			AutoRole:Damage1()
		end
	else
		if isDamageHidden then 
            		isDamageHidden = false
		end
	end
	--Tank
	if  self:IsEnabled() and  db.tankEnabled then 
		if not tankEnabled then
			isTankHidden = true
			AutoRole:Tank()
			AutoRole:Tank1()
		end
	else
		if not isTankHidden then
			isTankHidden = false
        	end
	end
	--Healer
	if self:IsEnabled() and  db.healerEnabled then 
		if not healerEnabled then
			isHealerHidden = true
           		AutoRole:Healer()
			AutoRole:Healer1()
		end
	else
		if not isHealerHidden then
			isHealerHidden = false
        	end
	end
end

function AutoRole:OnEnable()
	AutoRole:Update()
end

function AutoRole:OnDisable()
	AutoRole:Update()
end

function AutoRole:OnProfileChanged(db, name)
	AutoRole:Update()
end

function AutoRole:OnEvent(self, event, ...)
	if (event == "RAID_ROSTER_UPDATE") then
		AutoRole:Update()
	end
end  

function AutoRole:Damage()
	RolePollPopup:SetScript("OnShow",function() 
	if RolePollPopup.role~="DAMAGER" then 
	RolePollPopupRoleButtonDPS:Click() 
	end 
	RolePollPopupAcceptButton:Click() 
	end)
end

function AutoRole:Damage1()
	UnitSetRole("player","DAMAGER")
end

function AutoRole:Tank()
	RolePollPopup:SetScript("OnShow",function() 
	if RolePollPopup.role~="TANK" then 
	RolePollPopupRoleButtonTank:Click() 
	end 
	RolePollPopupAcceptButton:Click() 
	end)
end

function AutoRole:Tank1()
	UnitSetRole("player","TANK") 
end

function AutoRole:Healer()
	RolePollPopup:SetScript("OnShow",function() 
	if RolePollPopup.role~="HEALER" then 
	RolePollPopupRoleButtonHealer:Click() 
	end 
	RolePollPopupAcceptButton:Click() 
   	end)
end

function AutoRole:Healer1()
	UnitSetRole("player","HEALER")
end

function AutoRole:ChatCommand(input)
	if not input or input:trim() == "" then
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
	else
		LibStub("AceConfigCmd-3.0").HandleCommand(AutoRole, "autorole", input)
	end
end
